2017-03-30 23:47:57 +03:00
#!/bin/bash
set -euo pipefail
2017-05-12 21:14:22 +03:00
2017-03-30 23:47:57 +03:00
# Copyright 2017 Colin Walters <walters@verbum.org>
# Licensed under the new-BSD license (http://www.opensource.org/licenses/bsd-license.php)
# This script is intended to be used as a CI gating check
# that if a submodule is changed, the commit message contains
# the text:
#
# Update submodule: submodulepath
#
# It's very common for people to accidentally change submodules, and having this
# requirement is a small hurdle to pass.
2017-05-25 19:28:15 +03:00
# if running under PAPR, use the branch/PR HEAD actually
2017-05-12 21:14:22 +03:00
# being tested rather than the merge sha
2017-05-25 19:28:15 +03:00
HEAD = ${ PAPR_COMMIT :- HEAD }
2017-09-06 19:42:51 +03:00
dn = $( dirname $0 )
2018-02-22 22:16:33 +03:00
. ${ dn } /libpaprci/libbuild.sh
2017-05-12 21:14:22 +03:00
2017-03-30 23:47:57 +03:00
tmpd = $( mktemp -d)
touch ${ tmpd } /.tmpdir
cleanup_tmp( ) {
# This sanity check ensures we don't delete something else
if test -f ${ tmpd } /.tmpdir; then
rm -rf ${ tmpd }
fi
}
trap cleanup_tmp EXIT
2020-02-03 18:42:28 +03:00
if ! [ -x /usr/bin/git ] ; then
pkg_upgrade
pkg_install git
fi
2017-09-06 19:42:51 +03:00
2017-05-12 21:14:22 +03:00
gitdir = $( realpath $( pwd ) )
2017-03-30 23:47:57 +03:00
# Create a temporary copy of this (using cp not git clone) so git doesn't
# try to read the submodules from the Internet again. If we wanted to
# require a newer git, we could use `git worktree`.
cp -a ${ gitdir } ${ tmpd } /workdir
cd ${ tmpd } /workdir
2017-05-12 21:14:22 +03:00
git log --pretty= oneline origin/master..$HEAD | while read logline; do
2017-03-30 23:47:57 +03:00
commit = $( echo ${ logline } | cut -f 1 -d ' ' )
git diff --name-only ${ commit } ^..${ commit } > ${ tmpd } /diff.txt
git log -1 ${ commit } > ${ tmpd } /log.txt
echo " Validating commit for submodules: $commit "
git checkout -q " ${ commit } "
git submodule update --init
git submodule foreach --quiet 'echo $path' | while read submodule; do
if grep -q -e '^' ${ submodule } ${ tmpd } /diff.txt; then
echo " Commit $commit modifies submodule: $submodule "
expected_match = " Update submodule: $submodule "
if ! grep -q -e " $expected_match " ${ tmpd } /log.txt; then
2017-04-27 21:24:20 +03:00
sed -e 's,^,# ,' < ${ tmpd } /log.txt
2017-03-30 23:47:57 +03:00
echo " error: Commit message for ${ commit } changes a submodule, but does not match regex ${ expected_match } "
exit 1
fi
echo " Verified commit $commit matches regexp ${ expected_match } "
fi
done
done